'
' DotNetNuke -  http://www.dotnetnuke.com
' Copyright (c) 2002-2003
' by Shaun Walker ( sales@perpetualmotion.ca ) of Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Configuration
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.SqlTypes
Imports System.Reflection
Imports DotNetNuke

Public Class AdvancedEventsDB

    Private spPrefix as String = "AdvancedEvents_"


    Public Function GetAdvancedEvents(ByVal PortalId As Integer, Optional ByVal StartDate As String = "", Optional ByVal EndDate As String = "") As SqlDataReader

        ' Create Instance of Connection and Command Object
        Dim myConnection As New SqlConnection(GetDBConnectionString)

        ' Generate Command Object based on Method
        Dim myCommand As SqlCommand = SqlCommandGenerator.GenerateCommand(myConnection, _
            CType(MethodBase.GetCurrentMethod(), MethodInfo), _
            New Object() {PortalId, IIf(StartDate <> "", StartDate, SqlInt16.Null), IIf(EndDate <> "", EndDate, SqlInt16.Null)}, CommandType.StoredProcedure, spPrefix & "GetAdvancedEvents")

        ' Execute the command
        myConnection.Open()
        Dim result As SqlDataReader = myCommand.ExecuteReader(CommandBehavior.CloseConnection)

        ' Return the datareader
        Return result

    End Function


    Public Function GetSingleAdvancedEvent(ByVal ItemId As Integer) As SqlDataReader

        ' Create Instance of Connection and Command Object
        Dim myConnection As New SqlConnection(GetDBConnectionString)

        ' Generate Command Object based on Method
        Dim myCommand As SqlCommand = SqlCommandGenerator.GenerateCommand(myConnection, _
            CType(MethodBase.GetCurrentMethod(), MethodInfo), _
            New Object() {ItemId}, CommandType.StoredProcedure, spPrefix & "GetSingleAdvancedEvent")

        ' Execute the command
        myConnection.Open()
        Dim result As SqlDataReader = myCommand.ExecuteReader(CommandBehavior.CloseConnection)

        ' Return the datareader
        Return result

    End Function


    Public Sub DeleteAdvancedEvent(ByVal ItemID As Integer)
        Dim myConnection As New SqlConnection(GetDBConnectionString)

        ' Generate Command Object based on Method
        Dim myCommand As SqlCommand = SqlCommandGenerator.GenerateCommand(myConnection, _
            CType(MethodBase.GetCurrentMethod(), MethodInfo), _
            New Object() {ItemID}, CommandType.StoredProcedure, spPrefix & "DeleteAdvancedEvent")

        myConnection.Open()
        myCommand.ExecuteNonQuery()
        myConnection.Close()
    End Sub


    Public Sub AddAdvancedEvent(ByVal PortalId As Integer, ByVal Title As String, ByVal EventDate As Date, ByVal EndDate As String, ByVal Description As String, ByVal Category As Integer, ByVal Location As String, _
                                ByVal LocationAddress As String, ByVal ContactName As String, ByVal ContactEmail As String, ByVal ContactPhone as String, ByVal Featured as integer, ByVal Link as String, ByVal UserName As String)
        Dim myConnection As New SqlConnection(GetDBConnectionString)

        ' Generate Command Object based on Method
        Dim myCommand As SqlCommand = SqlCommandGenerator.GenerateCommand(myConnection, _
            CType(MethodBase.GetCurrentMethod(), MethodInfo), _
            New Object() {PortalId, Title, EventDate, IIf(EndDate <> "", EndDate, SqlInt16.Null), Description, Category, Location, LocationAddress, ContactName, ContactEmail, ContactPhone, Featured, Link, UserName, CreatedDate}, CommandType.StoredProcedure, spPrefix & "AddAdvancedEvent")

        myConnection.Open()
        myCommand.ExecuteNonQuery()
        myConnection.Close()
    End Sub


    Public Sub UpdateAdvancedEvent(ByVal ItemId As Integer, ByVal Title As String, ByVal EventDate As Date, ByVal EndDate As String, ByVal Description As String, ByVal Category As Integer, ByVal Location As String, _
                                    ByVal LocationAddress As String, ByVal ContactName As String, ByVal ContactEmail As String, ByVal ContactPhone as String, ByVal Featured as integer, ByVal Link as String, ByVal UserName As String)
        Dim myConnection As New SqlConnection(GetDBConnectionString)

        ' Generate Command Object based on Method
        Dim myCommand As SqlCommand = SqlCommandGenerator.GenerateCommand(myConnection, _
            CType(MethodBase.GetCurrentMethod(), MethodInfo), _
            New Object() {ItemId, Title, EventDate, IIf(EndDate <> "", EndDate, SqlInt16.Null), Description, Category, Location, LocationAddress, ContactName, ContactEmail, ContactPhone, Featured, Link, UserName}, CommandType.StoredProcedure, spPrefix & "UpdateAdvancedEvent")

        myConnection.Open()
        myCommand.ExecuteNonQuery()
        myConnection.Close()
    End Sub

End Class
